#import "BatchSwarm.h"
#import <gui.h>
#import "Parameters.h"
#import <misc.h>   //nsfprintf
#import <objectbase.h> 

@implementation BatchSwarm

+ createBegin: (id)aZone 
{
  BatchSwarm * obj;

  obj = [super createBegin: aZone];
  
  obj->displayFrequency = 1;
  
  return obj;
}

- createEnd 
{
  return [super createEnd];
}




- buildObjects 
{
  id modelZone;
  
  [super buildObjects];

  modelZone = [Zone create: [self getZone]];


  modelSwarm = [ModelSwarm create: modelZone];

  [modelSwarm buildObjects];

 
  return self;
}





- buildActions 
{
  [super buildActions];

  [modelSwarm buildActions];
 
   displayActions = [ActionGroup create: [self getZone]];
   [displayActions createActionTo: self message: M(checkToStop)];


   displaySchedule = [Schedule createBegin: [self getZone]];
   [displaySchedule setRepeatInterval: displayFrequency]; // note frequency!
   displaySchedule = [displaySchedule createEnd];
   [displaySchedule at: 0 createAction: displayActions];
 
  return self;
}


- (id <Activity>) activateIn: (id)swarmContext 
{
  [super activateIn: swarmContext];
  [modelSwarm activateIn: self];
  [displaySchedule activateIn: self];

  return [self getSwarmActivity];
}


-go
{
  printf("\nYou typed 'farmer -batchmode'.  The simulation is running without graphics.\n\n");
  printf("The experimentDuration %d", getInt(arguments,"duration"));
  if(displayFrequency)
    printf("It is checking to stop every %d timesteps.\n\n",
	   displayFrequency);

  [[self getActivity] run];
  return [[self getActivity] getStatus];
}
  

- checkToStop
{
  if ((int)getCurrentTime() == getInt(arguments,"duration"))
    {
      [getTopLevelActivity() terminate];
    }
  return self;
 
}


- (void)drop
{
  [modelSwarm drop];
}
 

@end








