// in Swarm. Copyright  1997 Nelson Minar
// This program is distributed without any warranty; without even the
// implied warranty of merchantability or fitness for a particular purpose.
// See file LICENSE for details and terms of copying.

#import <space.h>				  // we use Space features
#import <gui.h>
#import "FarmWorld.h"

// The definition of a Farmer object. We inherit code from the generic
// SwarmObject, which provides memory allocation and other niceties. It
// does not provide any sort of agent behaviour, though, that's up to us.
// First, there are a lot of state variables

@interface Farmer: SwarmObject
{
  int age;			
  int deathAge;			
  int idNumber;

  id modelSwarm;		
  FarmWorld *farmWorld;		
  
  id <List> acreList;

//   int currentSugar;			 
//   int metabolism;		
//   int vision;
			


  @public
  int x, y;					  // my position
  // Declared as public so other objects can use ->x to access x
}


- createEnd;

- (void)setIDNumber: (int)idnum;
- (int)getIDNumber;
- (int)getAcreage;

- (double)getProportionType: (unsigned)i;

- step;


- allocateResources;

- addAcre: (Acre *)anAcre;

- disclaimAllOwnership;

// data accessor functions.
// - (int)getMetabolism;
// - setMetabolism: (int)m;
// - setVision: (int)v
// - (int)getVision;
// - (int)getCurrentSugar;

- (int)getAge;
- (void)setModelSwarm: aSwarm;
- setDeathAge: (int)a;

// display code so you can see the agents moving.
- drawSelfOn: (id <Raster>)r;

- (void)sayHi;

- (void)drop;

@end
