// Sugarscape in Swarm. Copyright  1997 Nelson Minar
// This program is distributed without any warranty; without even the
// implied warranty of merchantability or fitness for a particular purpose.
// See file LICENSE for details and terms of copying.

#import "Farmer.h"
#import "Acre.h"
#import <simtools.h>
#import "ModelSwarm.h"
#import <gui.h>

@implementation Farmer


- createEnd
{
  acreList = [List create: [self getZone]];
  return [super createEnd];
}

- (void)setIDNumber: (int)idnum
{
  idNumber = idnum;
}

- (int)getIDNumber
{
  return idNumber;
}

- (int)getAcreage
{
  return [acreList getCount];
}

//CAUTION TODO: Following shows some agents with no acres.
// That's some problem, can't say what!


- (double)getProportionType: (unsigned)i
{
  int nCount = 0;
  id index = [acreList begin: [self getZone]];
  Acre * anAcre;
  for (anAcre = [index next]; [index getLoc]==Member; anAcre=[index next])
   {
     int useType = [anAcre getUseType];
     if (useType == i) nCount++;
   }
  [index drop];
  fprintf(stderr,"Farmer %d, acres type(%d) %d TotalAcreage=%d proportion =%f \n",idNumber, i, nCount, [acreList getCount], (double)nCount / (double)[acreList getCount]);
  if (nCount == 0) return nCount;
  else return (double)nCount / (double)[acreList getCount];
}



- step
{
  [self allocateResources];

  age++;

  // Check if I'm dying
  if ( age >= deathAge )
    {
      [farmWorld removeAgent: self];
      [modelSwarm agentDeath: self];
    }
  
  return self;
}


// randomly assigns land use
- allocateResources
{
  id index = [acreList begin: [self getZone]];
  Acre * anAcre;

  if ([acreList getCount ] > 0)
    for (anAcre = [index next]; [index getLoc]==Member; anAcre=[index next])
      {
	[anAcre setUseType: [uniformIntRand getIntegerWithMin: 0 withMax: (NUMTYPES-1)]];
      }
  [index drop];

#ifdef DEBUG
  {
    fprintf (stderr,"If I were debugging, I'd put code here and compile with the EXTRACPPFLAGS=-DDEBUG flag");
  }
#endif
  return self;
}



- addAcre: (Acre *)anAcre
{
  [acreList addLast: anAcre];
  return self;
}


- disclaimAllOwnership
{

 id index = [acreList begin: [self getZone]];
 Acre * anAcre;
 for (anAcre = [index next]; [index getLoc]==Member; anAcre=[index next])
   {
     [anAcre setOwner: nil];
     [index remove];
   }
 [index drop];
 return self;
}


- (void)setModelSwarm: aSwarm
{
  modelSwarm = aSwarm;
  farmWorld = [modelSwarm getFarmWorld];
 
}

// - (int)getCurrentSugar
// {
//   return currentSugar;
// }

// - setCurrentSugar: (int)cs
// {
//   currentSugar = cs;
//   return self;
// }

// - (int)getMetabolism
// {
//   return metabolism;
// }

// - setMetabolism: (int)m
// {
//   metabolism = m;
//   return self;
// }

// - (int)getVision
// {
//   return vision;
// }

// - setVision: (int)v
// {
//   vision = v;
//   return self;
// }

- (int)getAge
{
  return age;
}

- setDeathAge: (int)s
{
  deathAge = s;
  return self;
}

// Graphics code - how to draw oneself (hardcoded colour value here. If
// agents have different properties, these colour should be different.)
- drawSelfOn: (id <Raster>)r
{
  [r drawPointX: x Y: y Color: 100];
  return self;
}


- (void)sayHi
{
  fprintf(stderr,"Hi, I'm Farmer %d at %d %d \n",idNumber, x, y);
  fprintf(stderr,"I own %d acres, coordinates: ", [acreList getCount]);
  {
    id index = [acreList begin: [self getZone]];
    Acre * anAcre;
    for (anAcre = [index next]; [index getLoc]==Member; anAcre=[index next])
      {
	fprintf(stderr,"(%d, %d) ",[anAcre getX], [anAcre getY]);
      }
    [index drop];
    fprintf(stderr,"\n");
  }
}


- (void)drop
{
  [self disclaimAllOwnership];
  [acreList drop];
  [super drop];
}

@end
