#import <objectbase.h>
#import <objectbase/SwarmObject.h>
#import <simtools.h>
#import <analysis.h>
#import <space.h>

@class ModelSwarm;

@interface Output: SwarmObject
{
  @private
    BOOL dataFileExists; /*"Indicator that dataFile initialization has alreadyoccurred"*/
  BOOL graphsExist;

  char timeString[100];/*"a verbose description of current time"*/
  
  /*"FILE handle for output from C style fprintf"*/
  FILE * outputFile;


  id <Colormap> colorMap;                     // allocate colours

  ModelSwarm * modelSwarm;  
  
  int displayFrequency;				  // how often to update
  int drawPopulationGraph;			  // flag
  int drawWealthHistogram;			  // flag

  id <Colormap> colormap;			  // colours
  id <ZoomRaster> worldRaster;			  // window on world
  id <Value2dDisplay> weatherDisplay;		  // sugar displayer
  id <Object2dDisplay> agentDisplay;		  // agent displayer
  id <EZGraph> populationGraph;			  // population graph
  id <Array> popGraphSequences;

  //  id <EZGraph> attributeGraph;			  // agent attributes graph
  id <EZBin> wealthHistogram;			  // histogram of wealth

}

- buildObjects;

- (void)setModelSwarm: aSwarm;

- (void)createTimeString;

- prepareCOutputFile;

- writeCDataRun: (int)run Time: (long)theTime;

- printResults: (int)run Time: (long unsigned)theTime;

- step;

- (void)createGraphWriter;

- createRasters;


- (BOOL)checkToStop;

- (void)drop;



- _populationGraphDeath_ : caller;

- _wealthHistogramDeath_ : caller;


@end




