// This program is distributed without any warranty; without even the
// implied warranty of merchantability or fitness for a particular purpose.
// See file LICENSE for details and terms of copying.

#import "ObserverSwarm.h"
#import "BatchSwarm.h"
#import "Parameters.h"

#import <simtools.h>   // initSwarm macro
#import <simtoolsgui.h>

int
main (int argc, const char **argv)
{
  id observerSwarm;
  id topLevelActivity;

  initSwarmArguments (argc, argv, [Parameters class]);

  [(Parameters *)arguments init];
  CREATE_ARCHIVED_PROBE_DISPLAY (arguments);

  if (swarmGUIMode == 1)
  {
     observerSwarm = [ObserverSwarm createBegin: globalZone];
     SET_WINDOW_GEOMETRY_RECORD_NAME (observerSwarm);
   }
  else observerSwarm = [BatchSwarm createBegin: globalZone]; 
 
  observerSwarm = [observerSwarm createEnd];
  [observerSwarm buildObjects];
  [observerSwarm buildActions];
  topLevelActivity = [observerSwarm activateIn: nil];
  [observerSwarm go];

  [topLevelActivity drop];
  [observerSwarm drop];

  return 0;
}
